function [ relationMap ] = extractObjectsFromAllImageFiles(path, relationMap)
    fileList = dir(path);
    for i=1:length(fileList);
        if(fileList(i).isdir)
            if(strcmp(fileList(i).name,'.') || strcmp(fileList(i).name,'..'))
                continue;
            end
            [ relationMap ] = extractObjectsFromAllImageFiles(strcat(path,'/',fileList(i).name),...
                                                relationMap);
        else
            imagePath = strcat(path,'/',fileList(i).name);
            disp(imagePath);
            objectArray = read_annotation_xml(imagePath);
            objectNameArray = [];
            pairCount = 0;

            for obj=1:length(objectArray)
                if(sum(strcmp(objectArray(obj).Name,objectNameArray)) == 0)
                    pairCount = pairCount + 1;
                    objectNameArray(pairCount,:) = objectArray(obj).Name;
                end
            end
            
            objectNameArray = sort(objectNameArray);
            
            for obj1=1:length(objectNameArray)
                for obj2=(obj1+1):length(objectNameArray)
                    objectPairStr = strcat(objectNameArray(obj1),'#',objectNameArray(obj2));
                    count = 1;
                    if(isKey(relationMap,objectPairStr))
                        count = relationMap(objectPairStr) + 1;
                    end
                    relationMap(objectPairStr) = count;
                end
            end
           
        end
    end
end

