function [ indicatorImage ] = find_manmade_objects( imagePath, I, xWindows, yWindows )
%FIND_MANMADE_OBJECTS Summary of this function goes here
%   Detailed explanation goes here
warning('off','all');

if(nargin == 1)
    Igray = rgb2gray(imread(imagePath));
elseif(nargin == 2 && size(I,3) == 3)
    Igray = rgb2gray(I);
else
    Igray = I;
end
scale = 800 / max(size(Igray));
Igray = imresize(Igray,scale);

% xWindows = 20;
% yWindows = 20;

windowWidth = floor(size(Igray,2) / xWindows);
windowHeight = floor(size(Igray,1) / yWindows);

indicatorImage = false(yWindows,xWindows);
parfor x=1:xWindows
    for y=1:yWindows
        subImage = Igray( (1+(y-1)*windowHeight):(y*windowHeight),...
                          (1+(x-1)*windowWidth):(x*windowWidth) );
        featureMatrix = manmade_feature_extraction('',subImage);
        isManmade = manmade_object_detector(featureMatrix);
        indicatorImage(y,x) = isManmade;
    end
end


end

