close all;
clear all;
load('BW_canny.mat');

I  = imread('/home/jan/dtu/speciale/images/12.jpg');
Igray = imadjust(rgb2gray(I(1:2:end,1:2:end,:)));
BW = edge(Igray,'canny');

width = size(BW,2);
height = size(BW,1);

windowWidth = 15;
windowHeight = 15;

xWindows = floor(width/windowWidth);
yWindows = floor(height/windowHeight);

linearityMatrix = zeros(yWindows,xWindows);
for x=1:xWindows
    for y=1:yWindows
        sample = BW((1+(y-1)*windowHeight):(y*windowHeight),(1+(x-1)*windowWidth):(x*windowWidth));
        [ yWhite, xWhite ] = find(sample == 1);
        linearity = 10;
        if(length(xWhite) >= 5)
            p = polyfit(xWhite,yWhite,1);
            yFit = polyval(p,xWhite);
            residuals = abs(yWhite - yFit);
            linearityX = mean(residuals);
            
            p = polyfit(yWhite,xWhite,1);
            xFit = polyval(p,yWhite);
            residuals = abs(xWhite - xFit);
            linearityY = mean(residuals);
            linearity = min(linearityX,linearityY);
        end
        linearityMatrix(y,x) = linearity;
    end
end
linearityMatrix = linearityMatrix / max(linearityMatrix(:));

% xWindows = width - windowWidth;
% yWindows = height - windowHeight;
% 
% linearityMatrix = zeros(yWindows,xWindows);
% for x=1:xWindows
%     for y=1:yWindows
%         sample = BW(y:(y+windowHeight),x:(x+windowWidth));
%         [ yWhite, xWhite ] = find(sample == 1);
%         linearity = 100;
%         if(length(xWhite) >= 5)
%             p = polyfit(xWhite,yWhite,1);
%             yFit = polyval(p,xWhite);
%             residuals = abs(yWhite - yFit);
%             linearity = mean(residuals);
%         end
%         linearityMatrix(y,x) = linearity;
%     end
% end

figure, image((linearityMatrix<0.4*mean(linearityMatrix(:)))*60), colormap gray;
figure, image(linearityMatrix*60), colormap gray;
