function [ xmlTree ] = read_annotation_xml( imagePath )
%READ_ANNOTION_XML Read annotions for the requested image.
%   Detailed explanation goes here


annotationFilePath = strrep(imagePath,'Images','Annotations');
annotationFilePath = strrep(annotationFilePath,'.jpg','.xml');
%disp(annotationFilePath);

tree = parseXML(annotationFilePath);

maxPtCount = 0;

objectLevel = getChildrenByName(tree,'object');
polygonCount = length(objectLevel);
xmlTree = repmat(struct('Name',cell(1,1),'Polygon',zeros(1,2)),polygonCount,1);
for i2=1:length(objectLevel)
   nameLevel = getChildrenByName(objectLevel(i2),'name');
   nameStr = strtrim(nameLevel.Children(1).Data);
   %disp(strcat('Object: ',nameStr));
   polygonLevel = getChildrenByName(objectLevel(i2),'polygon');
   ptLevel = getChildrenByName(polygonLevel(1),'pt');
   %disp('Polygon:');
   if(length(ptLevel) > maxPtCount)
       maxPtCount = length(ptLevel);
   end
   ptArray = zeros(length(ptLevel),2);
   for i3=1:length(ptLevel)
      xLevel = getChildrenByName(ptLevel(i3),'x');
      yLevel = getChildrenByName(ptLevel(i3),'y');
      xCoord = str2double(xLevel(1).Children(1).Data);
      yCoord = str2double(yLevel(1).Children(1).Data);
      ptArray(i3,:) = [ xCoord, yCoord ];
      %disp(strcat(num2str(xCoord),' - ',num2str(yCoord)));
   end
   xmlTree(i2).Name = nameStr;
   xmlTree(i2).Polygon = ptArray;
end

end

function [ children ] = getChildrenByName( node, name )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

childrenCount = length(node.Children);
matchCount = 0;
templateStruct = [];
for i=1:childrenCount
    if(strcmp(node.Children(i).Name,name))
        matchCount = matchCount + 1;
        if(matchCount == 1)
            templateStruct = node.Children(i);
        end
    end
end
children = repmat(templateStruct,matchCount,1);
matchCount = 0;
for i=1:childrenCount
    if(strcmp(node.Children(i).Name,name))
        matchCount = matchCount + 1;
        children(matchCount) =  node.Children(i);
    end
end

end