%% DESCRIPTION
% The idea is to extract regions of a given intensity range and perform
% linear regression, to identify the boundaries of blobs.
% This script extracts regions with similar intensity and detect edges
% which separate regions of different intensities.

close all;
clear all;

% Load image:
I = imread('../../images/12_small.jpg');
%run('../copy_movie_to_smaller_array.m');
%I = small_mov(70).cdata;
Igray = rgb2gray(I);

edgeHistory = zeros([size(Igray),25]);
for j=1:25
    % Set the center-intensity
    selectedIntensity = 10*j;
    % Set the interval width
    selectionIntervalRadius = 50;
    
    lowerBound = selectedIntensity - selectionIntervalRadius;
    upperBound = selectedIntensity + selectionIntervalRadius;
    mask = Igray >= lowerBound & Igray <= upperBound;

    initialSelection = Igray.*uint8(mask);
    %image(initialSelection*0.3), colormap gray;
    imagesc(mask), colormap gray;
    
    % Find edges
    B = edge(mask,'canny');
    % Save edges
    edgeHistory(:,:,j) = B;
    waitforbuttonpress;
end
% Find and show edges which are common for several regions of similar
% intensity.
meanEdge = mean(edgeHistory,3);
figure, imagesc(meanEdge), colormap gray;
figure, imagesc(meanEdge > 0.2), colormap gray;