%% DESCRIPTION
% Visualize the hat matrix H and show the effect of changing the response by
% one unit

close all;
clear all;

Xlength = 20;
X = floor(rand(Xlength,2)*diag([ 35, 12 ]));
X(:,1) = X(:,1) - mean(X(:,1));
X(:,2) = X(:,2) - mean(X(:,2));

XX = X'*X
iXtX = inv(XX)

XiXtX = X * iXtX;
H = XiXtX * X';

% Show the effect of changing the response by one unit
y = zeros(20,1);
for i=1:Xlength
    y(i) = 1;
    yhat = H*y
    y(i) = 0;
end

% Show data and leverage scores:
figure();
scatter(X(:,1),X(:,2),20,diag(H));
% Show H
figure();
imageH = (H-min(H(:)));
imageH = (60/max(imageH(:)))*imageH;
image(imageH);

% Show y versus yHat
figure();
plot(y,yhat,'*');