function leverage_visualization( X, leverageScores )
%LEVERAGE_VISUALIZATION Visualize the leverage scores of observations with a colored
%surface

% Find the best rectangular box containing all data
Xmin = nanmin(X(:,1));
Xmax = nanmax(X(:,1));
Ymin = nanmin(X(:,2));
Ymax = nanmax(X(:,2));
resolutionX = (Xmax-Xmin) / 500;
resolutionY = (Ymax-Ymin) / 500;

% Generate a grid on which the interpolated leverage scores are computed
[ Xgrid, Ygrid ] = meshgrid(Xmin:resolutionX:Xmax,Ymin:resolutionY:Ymax);
Zgrid = griddata(X(:,1),X(:,2),leverageScores,Xgrid,Ygrid);

% Show the surface and data
figure, surface(Xgrid,Ygrid,Zgrid,'LineStyle','none','FaceAlpha',0.7);
hold on; scatter(X(:,1),X(:,2),'k+'); hold off;

end

