%% DESCRIPTION
% Illustrate several good logistic function fits for separable 1d-data.

close all;
clear all;

addpath('..');

X = [ -3:0.2:-1 , 1:0.2:3 ];
y = [ zeros(1,11), ones(1,11) ];
plot(X,y);
reportPlot('plot','Logistic fits',[- 4; 4],'X',[0 ; 0],'Y');
hold on; plot(X(1:11),y(1:11),'*r','LineWidth',5); hold off;
hold on; plot(X(12:end),y(12:end),'+r','LineWidth',5); hold off;
axis([-3, 3, -0.1, 1.1 ]);

x = -3:0.1:3;
logisticF1 = 1 -(1 ./ (1+exp(5*x)));
logisticF2 = 1 - (1 ./ (1+exp(-1+10*x)));
logisticF3 = 1 - (1 ./ (1+exp(1+10*x)));
hold on; plot(x,logisticF1,'k','LineWidth',2); hold off;
hold on; plot(x,logisticF2,'k','LineWidth',2); hold off;
hold on; plot(x,logisticF3,'k','LineWidth',2); hold off;