%% DESCRIPTION
% Study the reltation between leverage scores and distance for different
% data distributions.
% Generate data from one or two Gaussians, suitably separated, and calculate
% leverage scores.

close all;
clear all;
run('../plot_settings.m');

elementsCluster1 = 3000;
elementsCluster2 = 0;
elements = elementsCluster1 + elementsCluster2;

%X = rand(elements,2)*diag([1,3]);
%X = normrnd(1,1,elements,2);
X = mvnrnd(zeros(1,2),[4, 1; 1, 1],elements);
%X = mvtrnd([1, 1; 1, 100],3,elements);
%X(:,1) = normrnd(1,1,elements,1);
%X(:,2) = rand(elements,1);
%X = rand(elements,2)*[ 1 0 ; 0 5 ];
%X(:,1) = rand(elements,1);
% for i=1:elements
%     X(i,2) = 2*X(i,1) + 0.1*rand;
% end

% 0-mean:
% X(:,1) = X(:,1) - mean(X(:,1));
% X(:,2) = X(:,2) - mean(X(:,2));

H = zeros(elements,1);

iXTX = inv(X'*X);

for i=1:elements
   H(i) = X(i,:) * iXTX * X(i,:)';
end

distance = sqrt(sum(X.^2,2));
distance = distance / sum(distance);
ratio = H ./ distance;

%plot(X(:,1),X(:,2),'*');
figure(1);
scatter(X(:,1),X(:,2),20,H);
axis square
%axis([ -0.5, 0.5, -0.5, 0.5 ]);

figure(2);
scatter(distance,sqrt(H));
% hold on;
% straightLine = @(x) x;
% plot(0:0.00001:0.002,69*(0:0.00001:0.002),'r','LineWidth',2);
% hold off;
xlabel('Distance from mean');
ylabel('Leverage score');
title('Leverage score vs. distance from mean');

% Visualize the ratio of distance and leverage scores.
figure(3);
scatter(X(:,1),X(:,2),20,log(ratio)), colorbar;