%% DESCRIPTION
% Load video into the appropriate MATLAB structures for further processing.
% It might be a good idea to save the structure afterwards for faster
% loading.

clear all;

% Define path to video file
videoObj = VideoReader('/home/jan/Videoklip/speciale/bang_youre_dead.avi');

% Downsample framerate to a chosen level
targetFrameRate = 8;
frameRateRescale = videoObj.FrameRate / targetFrameRate;

% Get number and size of frames (with new framerate)
nFrames = floor(videoObj.NumberOfFrames / frameRateRescale);
vidHeight = videoObj.Height;
vidWidth = videoObj.Width;

% Preallocate movie structure.
mov(1:nFrames) = ...
    struct('cdata', zeros(vidHeight, vidWidth, 'uint8'),...
           'colormap', []);

% Read one frame at a time.
for k = 1 : nFrames
    mov(k).cdata = rgb2gray(read(videoObj, floor(k*frameRateRescale)));
    if(mod(k,20) == 0)
        disp(k);
    end
end

% Open a figure based on the video's width and height.
% hf = figure;
% set(hf, 'position', [150 150 vidWidth vidHeight])

% Play back the movie once at the video's frame rate.
% implay(mov);